#!/usr/bin/env ansible-playbook
---

- name: Config dc to match ptfconfig
  hosts: "{{ENV_NAME}}-samba-dc"
  tasks:

    - name: render script to create samba users
      template:
        src: "templates/{{test_suite_name}}/config-dc.sh"
        dest: "{{ansible_env.HOME}}/config-dc.sh"
        mode: 0755

    - name: run script to create samba users
      become: yes
      shell: "{{ansible_env.HOME}}/config-dc.sh"


- name: Windows initial setup
  hosts: "{{ENV_NAME}}-windows-common"
  vars:
    master_hostname: "{{primary_dc_name}}"
    master_priv_ip: "{{ hostvars[primary_dc_name].openstack.private_v4 }}"
    master_fqdn: "{{ primary_dc_name }}.{{ samba_realm|lower }}"
    master_service_salt: "{{ samba_realm }}host{{ master_fqdn }}"

    windows_hostname: "{{ansible_hostname}}"
    windows_fqdn: "{{ windows_hostname }}.{{ samba_realm|lower }}"
    windows_service_salt: "{{ samba_realm }}host{{ windows_fqdn }}"
    windows_ip: "{{openstack.public_v4}}"
    windows_priv_ip: "{{openstack.private_v4}}"

  tasks:
    - name: Install Prerequisites for test suite
      win_shell: "C:\\InstallPrerequisites.ps1 -Category {{ test_suite_category }} -ConfigPath C:\\PrerequisitesConfig.xml"

    - name: win_stat MSTEST
      win_stat:
        path: "{{MSTEST}}"
      register: win_stat_result

    - name: make sure MSTEST exists
      fail:
        msg: "MSTest not exsits: {{MSTEST}}"
      when: not win_stat_result.stat.exists

    - name: Install MSI for test suite
      win_package:
        path: "C:\\{{ test_suite_msi }}"
        state: present
      ignore_errors: yes

    - name: render ptfconfig for test suite
      win_template:
        src: "templates/{{ test_suite_name }}/{{ test_suite_ptfconfig }}"
        dest: "{{ test_suite_bin }}\\{{ test_suite_ptfconfig }}"

    - name: config the DNS client on Windows network adapters
      win_dns_client:
        adapter_names: "Ethernet"
        ipv4_addresses: ["{{master_priv_ip}}", 202.78.247.199]

    - name: join domain
      win_domain_membership:
        dns_domain_name: "{{samba_realm}}"
        domain_admin_user: "{{samba_user}}@{{samba_domain}}"
        domain_admin_password: "{{samba_password}}"
        state: domain
      register: win_domain_membership
      tags: join_domain

    - name: Set machine account password
      win_shell: "ksetup /SetComputerPassword {{samba_password}}"
      # should have done in windows-common

    - name: reboot after join domain
      win_reboot:
      # when: win_domain_membership.reboot_required

    - name: render run.cmd
      win_template:
        src: "templates/{{ test_suite_name }}/run.cmd"
        dest: "C:\\run.cmd"

    - name: rm testresult
      win_file:
        path: "{{test_result_file}}"
        state: absent

    - name: run pexpect script to trigger test
      local_action: command {{playbook_dir}}/scripts/wpts-run.py {{windows_ip}} {{samba_user}}@{{samba_domain}} {{samba_password}}

    - name: wait for testresult
      win_wait_for:
        path: "{{test_result_file}}"

    - name: fetch testresult
      fetch:
        src: "{{test_result_file}}"
        dest: "/tmp/testresult.trx"
        flat: yes

    - name: set fact for parse_trx cmdline
      set_fact:
        cmdline: "{{playbook_dir}}/scripts/parse-trx.py --trx /tmp/testresult.trx"
      tags: parse-trx

    - name: parse trx file and convert format
      local_action: command {{cmdline}}
      register: parse_trx_result
      tags: parse-trx

    - debug: var=cmdline
      tags: parse-trx
